//
// utils.cc
//
// hexadecimal convert functions (string to several byte formats and back)
//
#include <iostream>
#include <string.h>

using namespace std;

#include "utils.h"

const int HEX_OUTPUT_LENGTH=32;

// return hexadecimal character representing x
char hexdigit(int x)
{
	if (x<10)
		return '0'+x;
	if (x<16)
		return 'a'+x-10;
	return 'X';
}

// store hex representation of byte array x[ ]
char *output_hex(const BYTE *x,int l) 
{
	static char hex_output[HEX_OUTPUT_LENGTH];
	int j;

	for (j=0;j<l;j++)
	{
		hex_output[2*j]=hexdigit(x[j]>>4);
		hex_output[2*j+1]=hexdigit(x[j]&0xf);
	}
	hex_output[2*l]=0;
	return hex_output;
}

// convert hexdigit character to value
int hexdigit_to_halfbyte(char ch)
{
	if (ch>='0' && ch<='9') 
		return ch-'0';
	if (ch>='a' && ch<='f') 
		return ch-'a'+10;
	if (ch>='A' && ch<='F') 
		return ch-'A'+10;
	return 0;
}

// convert hexdigit string to byte value
BYTE input_hex_byte(const char *hex_input) 
{
	int hl;

	hl=strlen(hex_input);

	if ((hl==0) || (hl>2))
		return 0;
	if (hl==1)
		return hexdigit_to_halfbyte(hex_input[0]);
	else // hl==2
		return (hexdigit_to_halfbyte(hex_input[0])<<4) 
			|hexdigit_to_halfbyte(hex_input[1]);
}

// convert hexdigit string to word value
WORD input_hex_word(const char *hex_input) 
{
	int hl;

	WORD w;

	hl=strlen(hex_input);

	if ((hl==0) || (hl>4))
	{
		cout << "input_hex_word cannot read string, length=" << hl << endl;
		return 0;
	}
	
	w=(WORD)hexdigit_to_halfbyte(hex_input[0]);

//	cout  << "w=" << hex << w << endl;
	if (hl==1)
		return w;
	w=(w<<4)|(WORD)hexdigit_to_halfbyte(hex_input[1]);
//	cout << "w=" << hex << w << endl;

	if (hl==2)
		return w;
	w=(w<<4)|(WORD)hexdigit_to_halfbyte(hex_input[2]);
//	cout << "w=" << hex << w << endl;

	if (hl==3)
		return w;
	w=(w<<4)|(WORD)hexdigit_to_halfbyte(hex_input[3]);
//	cout << "w=" << hex << w << endl;

	return w;
}

// convert hexdigit string to byte string
int input_hex(BYTE *x, const char *hex_input) 
{
	int hl;
	int j;
	int k;

	hl=strlen(hex_input);
	k=-1;
	for (j=0;j<hl;j++)
	{
		if (j%2==0)
		{
			k++;
			x[k]=hexdigit_to_halfbyte(hex_input[j])<<4;
		}
		else
			x[k]|=hexdigit_to_halfbyte(hex_input[j]);
	}
	return k+1;
}

